window.wo = {};
(function($,wo){
	//通用函数
	wo.geturl = function() {
		var url = location.search;	var rtn = new Array; 
		if ((url) && (url.indexOf("?") >= 0)) {  var str = url.substr(1); 
			if (str) { var strs = str.split("&"); if (strs.length > 0) {
						for(var i = 0; i < strs.length; i ++) {  rtn[strs[i].split("=")[0]]=unescape(strs[i].split("=")[1]); };
					};};}; 
		return rtn; 
	};
	wo.format_time = function(oldtime){
		var t = new Date().getTime(); t = t/1000; var time = t - Number(oldtime);
		if (time < 60) { 
			return "刚刚";
		} else if (time < 3600) {
			return parseInt(time / 60) + "分钟前";
		} else if (time < 86400) {
			return parseInt(time / 3600) + "小时前";
		} else if (time < 604800) {
			return parseInt(time / 86400) + "天前";
		} else if (time < 2592000) {
			return parseInt(time / 604800) + "周前";
		} else if (time < 31536000) {
			return parseInt(time / 2592000) + "个月前";
		} else {
			return parseInt(time / 31536000) + "年前";
		};
	};
	//获取圈子数据
	wo.getgroup = function(uid, gid, callback){
		var sql = ' SELECT * FROM WQ_System WHERE name = "GroupType" '; 
		wo.query(sql,[], function(results){
			if (results.rows.length > 0) {
				var gtype = JSON.parse(results.rows.item(0).value);
				var sql = ' SELECT * FROM WQ_Group WHERE uid = ? AND gid = ? '; 
				wo.query(sql,[uid, gid], function(results){
					if (results.rows.length > 0) {
						var ginfo = results.rows.item(0);
						wo.getimgthumb(ginfo.avatar, function(path){
							ginfo.thumb_path = (path) ? path : '../image/default_avatar.png';
							wo.getimgthumb(ginfo.gavatar, function(path){						
								ginfo.gthumb_path = (path) ? path : gtype[ginfo.gtype - 1]['default_avatar'];
								ginfo.gtype_name = (ginfo.gtype < 10) ? gtype[ginfo.gtype - 1]['type_name'] : '普通';
								callback && callback(ginfo);
							});
						});
					}else{
						callback && callback(null);
					}
				});	 
			}else{
				console.log('读取圈子类型错误！');
				callback && callback(null);
			}
		}); 
	};
	//获取用户
	wo.getuser = function(buid, bgid, callback){
		bgid = bgid || '0';
		var sql = ' SELECT * FROM WQ_User WHERE uid = ? AND gid = ? ';
		wo.query(sql, [buid, bgid], function(results){
			if (results.rows.length > 0) {
				var uinfo = results.rows.item(0);
				wo.getimgthumb(uinfo.avatar, function(path){
					uinfo.thumb_path = (path) ? path : '../image/default_avatar.png';
					callback && callback(uinfo);
				});
			}else{
					var sql = "SELECT value FROM WQ_System WHERE name = 'LoginStatus';";
					wo.query(sql, [], function(results){
						if (results && results.rows.length>0){
				    		var udata = JSON.parse(results.rows.item(0).value);
				    		var uid = udata.uid;
							var url = 'user/get';
							var param = { uid:uid, bgid: bgid, buid: buid };
							wo.post(url, param, function(data){
								if (data.code == '1') {
									var uinfo = data.info;
									if (uinfo) {
										wo.getimgthumb(uinfo.avatar, function(path){
											uinfo.thumb_path = (path) ? path : '../image/default_avatar.png';
											var sql = ' INSERT INTO WQ_User (uid, gid, avatar, nickname, level, addtime) VALUES (?,?,?,?,?,?) ';
											wo.update(sql, [uinfo.uid, uinfo.gid, uinfo.avatar, uinfo.nickname, uinfo.level, uinfo.addtime], function(){
												callback && callback(uinfo);
											});
										});
									}else{
										callback && callback(null);
									};
								}else{
									callback && callback(null);
								};
							},function(err){
								callback && callback(null);					
							});				    		
				    	}else{
				    		callback && callback(null);		
				    	};
					});				
			};
		});
	};

	wo.edituser = function(uid, key, value, callback, old_pwd){
		var sql = "SELECT * FROM WQ_System WHERE uid = ? AND name = ? ";
		wo.query(sql, [uid, 'LoginParam'], function(results){
			if (results && results.rows.length > 0) {
				var uinfo = JSON.parse(results.rows.item(0).value);
				eval('uinfo.'+key+'="'+value+'"');
				var sql = "UPDATE WQ_System SET value = ? WHERE uid = ? AND name = ? ";
				wo.update(sql, [JSON.stringify(uinfo), uid, 'LoginParam'], function(){
					var url = 'user/edit';
					var param = {uid: uid, key:key, value: value}; 
					if (old_pwd) {
						eval('param.oldpassword ="'+old_pwd+'"');
					}
					wo.post(url, param, function(data){
						if (data.code == 1) {
							callback && callback(true);
						}else{
							mui.toast(data.msg);
							callback && callback(null);
						}
					}, function(err){
						mui.toast('更改头像失败，请重试');
						callback && callback(null);
					});
				});
			}else{
				callback && callback(null);
			}
		});
	}

	wo.editgroupuser = function(uid, gid, key, value, callback, type){
		if (key == 'nickname' || key == 'avatar' || key == 'blog_remd' || key == 'talk_remd' || key == 'msg_remd' || key == 'notify_remd' || key == 'is_top' || key == 'level'){
			var sql = (type) ? "UPDATE WQ_User SET "+key+" = '"+value+"' WHERE uid = ? AND gid = ?" : "UPDATE WQ_Group SET "+key+" = '"+value+"' WHERE uid = ? AND gid = ?";
			wo.update(sql, [uid, gid], function(){
				var url="group/edituser";
				var param = {uid:uid, gid:gid, key:key, value:value};
				wo.post(url, param, function(data){
					if (data.code == 1) {
						if (key == 'nickname' || key == 'avatar') {
							var sql = "UPDATE WQ_User SET "+key+" = '"+value+"' WHERE uid = ? AND gid = ? ";
							wo.update(sql, [uid, gid], function(){
								callback && callback(true);
							});
						}else{
							callback && callback(true);
						}
					}else{
						callback && callback(null);
					}
				}, function(err){ callback && callback(null); });
			});
		}else{
			callback && callback(null);
		}
	}
	
	wo.editgroup = function(uid, gid, key, value, callback){
		if (key == 'gname' || key == 'gavatar' || key == 'mem_size' || key == 'description' || key == 'auth_join' || key == 'auth_invcode'){
			var sql = "UPDATE WQ_Group SET "+key+" = '"+value+"' WHERE uid = ? AND gid = ?";
			wo.update(sql, [uid, gid], function(){
				var url="group/edit";
				var param = {uid:uid, gid:gid, key:key, value:value};
				wo.post(url, param, function(data){
					if (data.code == 1) {
							callback && callback(true);
					}else{
						mui.toast(data.msg);
						callback && callback(null);
					}
				}, function(err){ callback && callback(null); });
			});
		}else{
			callback && callback(null);
		}
	}
	
	wo.entmsg = function(uid, gid, b_uid){
		var sql = " SELECT * FROM WQ_MsgGroup WHERE uid = ? AND gid = ? AND ( member LIKE ? OR member LIKE ? ) ";
		wo.query(sql, [uid, gid, ','+String(b_uid), String(b_uid)+','], function(results){
			if (results && results.rows.length > 0) {
				var mgid = results.rows.item(0).mgid;
				mui.openWindow({url:"groupmsg.html?uid="+uid+'&gid='+gid+'&mgid='+mgid, id:"groupmsg"+mgid, show:{aniShow: 'zoom-fade-out'}});
			}else{
				var url = 'msg/getmg';
				var param = {uid: uid, gid: gid, buid: b_uid};
				wo.post(url, param, function(data){
					if (data.code == 1) {
						var mg = data.info;
						var mgid = mg.mgid;
						var sql = "INSERT INTO WQ_MsgGroup (mgid, uid, gid, type, mgavatar, mgname, member, remd, createtime, last_msg_addtime) SELECT ?,?,?,?,?, ?,?,?,?,? WHERE NOT EXISTS ( SELECT 1 FROM WQ_MsgGroup WHERE mgid = ? ) ";
						wo.update(sql, [mg.mgid, mg.uid, mg.gid, mg.type, mg.mgavatar, mg.mgname, mg.member, 1, mg.create_time, mg.last_msg_addtime, mg.mgid], function(){
						mui.openWindow({url:"groupmsg.html?uid="+uid+'&gid='+gid+'&mgid='+mgid, id:"groupmsg"+mgid, show:{aniShow: 'zoom-fade-out'}});	
						});
					}else{
						wo.tip(data.msg);
					}
				},function(err){ wo.tip('进入私聊错误，请重试') });
			}
		});
	}
	
	//IMG-图片下载和缓存 
	var DIR_IMAGE = "_doc/";
	var Wo_ImageList = new Array;
	wo.getimgs = function(arrimgid, callback){
		if (arrimgid.length > 0) {
			var imgid = arrimgid.shift(); 
			if (imgid) {   
				wo.getimgthumb(imgid, function(path){
					if (path) {
						var img = { imgid: imgid, thumb_path: path };
						Wo_ImageList.push(img);
					}
					wo.getimgs(arrimgid, callback);
				});
			}else{
				wo.getimgs(arrimgid, callback);
			}
		}else{
			var rtnData = Wo_ImageList; 
			Wo_ImageList = [];
			callback && callback(rtnData);
		}
	};
	wo.getimgthumb = function(imgid, callback){
		if (imgid) { _getimg(imgid, 'thumb', callback); } else { callback && callback(null); };
	};
	wo.getimgfull = function(imgid, callback){
		if (imgid) { _getimg(imgid, 'full', callback); } else { callback && callback(null); };
	}
	var _getimg = function(imgid, type, successCallback){
		if (type != 'thumb' && type != 'full') return successCallback(null);
		var sql = "SELECT * FROM WQ_Img WHERE imgid = ? ";
		if (imgid) {
			wo.query(sql, [imgid], function(results){
				if (results.rows.length > 0){
					var img = results.rows.item(0);
					var path = (type == 'thumb') ? img.thumb_path : img.full_path;
					if (path) {
						successCallback(path);
					}else{
						_getimgserver(imgid, type, function(path){
							successCallback(path);
						});
					}
				}else{
					_getimgserver(imgid, type, function(path){
						successCallback(path);
					});
				}
			});
		}else{
			successCallback(null);
		}
	};
	var _getimgserver = function(imgid, type, callback){
		var url = 'image/getUrl';
		var param = {imgid: imgid};
		wo.get(url, param, function(data){
			if (data.code != '1' || data.info.length == 0) return callback(null);
			var imgUrl = (type == 'thumb') ? data.info.thumb_path : data.info.full_path;
			var filename = String(imgid) + type + '.png'; 
			_downloadImg(filename, imgUrl, function(path){ 
				var arrSql = new Array;
				if (type == 'thumb') {
					arrSql.push("INSERT INTO WQ_Img (imgid, thumb_path) SELECT " + imgid + ",'" + path + "' WHERE NOT EXISTS (SELECT 1 FROM WQ_Img WHERE imgid = "+imgid+")");
					arrSql.push("UPDATE WQ_Img SET thumb_path = '"+path+"' WHERE imgid = "+imgid+" ");
				}else{
					arrSql.push("UPDATE WQ_Img SET full_path = '"+path+"' WHERE imgid = "+imgid+" ");
				}
				wo.excute(arrSql, function(){
					callback && callback(path);
				});
			}).start();
		}, function(err){
			callback(null);
		});
	};
	var _downloadImg = function(name, imgUrl, successCallback){

		var task = plus.downloader.createDownload(imgUrl, { timeout: 60, retry: 4 }, 
			           function(download, status) { 
						    if (status != '200') {
								return successCallback(null);
							}					    
						    var path = _filenametoUrl(download.filename);
							successCallback(path);
				   });
		task.addEventListener("statechanged", function(d,status){ 
			if (status == '404') {
				task.abort();
				return successCallback(null); 
			}
		}, false);
		return task;
	};
	var _filenametoUrl = function(filename){
	    var path = plus.io.convertLocalFileSystemURL(filename);
		path = (0 != path.toString().indexOf("file://")) ? 'file://' + path : path;
		return path;
	};
	
	//UI-弹出对话框 
	var body = document.getElementsByTagName('body')[0];
	var mask, tip_type, mask_close;
	
	wo.tip = function(msg, type, callback){
		tip_type = type || 'pop';
		mask_close = (!type || type == 'pop') ? true : false;
		callback = callback || false;
		var _span = document.createElement('span');
		var _div = document.createElement('div');
		_div.className = 'wo-pop-box';
		_span.innerText = msg;
		_div.appendChild(_span);
		mask = mui.createMask(_maskback);
		mask.show();
		body.appendChild(_div);
		_div.style.marginLeft = - _div.offsetWidth/2 + 'px';
		_div.style.marginTop = - _div.offsetHeight/2 + 'px'; 
		
		if (callback) {
			_div.addEventListener('tap', function(){
				mask_close = true;
				mask.close();
				callback();
			});
		}else{
			var maskback = body.querySelector('.mui-backdrop');
			maskback.addEventListener('tap', function(){
				mask.close();
				_maskback();
			});
		}
	};
	
	wo.tipbox = function(opt, abtnCallback, cbtnCallback){
		var tip_title = (opt.title) ? opt.title : false;
		var tip_content = (opt.content) ? opt.content : '';
		var abtn_txt = (opt.abtn) ? opt.abtn : '知道了';
		var cbtn_txt = (opt.cbtn) ? opt.cbtn : false;
        var _div = document.createElement('div');
        var _title = document.createElement('div');
        var _line = document.createElement('div');
        var _content = document.createElement('div');
        var _btnbox = document.createElement('div');
        var _abtn = document.createElement('button');
        var _cbtn = document.createElement('button');
        _div.className = 'wo-tip-box';
        _title.className = 'title wo-font-blue';
        _line.className = 'line';
        _content.className = 'content';
        _btnbox.className = 'btn-box';
        _abtn.className = 'mui-btn mui-btn-positive wo-abtn';
        _cbtn.className = 'mui-btn wo-cbtn';
        _title.innerText = tip_title;
        _content.innerText = tip_content;
        _abtn.innerText = abtn_txt;
        _cbtn.innerText = cbtn_txt;
        if (tip_title) {
        	_title.appendChild(_line);
        	_div.appendChild(_title);
        }else{
        	_content.style.marginTop = '5px';
        }
        _div.appendChild(_content);
        _btnbox.appendChild(_cbtn);
        _btnbox.appendChild(_abtn);
        _div.appendChild(_btnbox);
        mask_close = false;
        mask = mui.createMask(_maskback);
        mask.show();
        body.appendChild(_div);
        _div.style.marginLeft = -_div.offsetWidth / 2 + 'px';
        _div.style.marginTop = -_div.offsetHeight / 2 + 'px';
        
        if (abtnCallback) {
        	_abtn.addEventListener('tap', function(){
        		mask_close = true;
				mask.close();
				_maskback();
				abtnCallback();
        	});
        };
        
        if (cbtnCallback) {
        	_cbtn.addEventListener('tap', function(){
        		mask_close = true;
				mask.close();
				_maskback();
				cbtnCallback();
        	});
        };
	};

	wo.selectbox = function(arrSelect, callback){
		mask_close = true;
		var _div = document.createElement('div');
		_div.className = 'wo-pop-box';
		_div.style.padding = '0px 10px';
		var _ul = document.createElement('ul');
		_ul.className = 'mui-table-view';
		for (var i=0; i<arrSelect.length; i++){
		    var _li = document.createElement('li');
		    _li.className = 'mui-table-view-cell';
		    _li.setAttribute('id', arrSelect[i].id);
		    _li.innerText = arrSelect[i].text;
		    _li.addEventListener('tap',function(){
		    	var cli = this;
		    	mask_close = true;
				mask.close();
				var cid = cli.getAttribute('id');
				callback(cid);
		    });
			_ul.appendChild(_li);
		}
		_div.appendChild(_ul);
		mask = mui.createMask(_maskback);
		mask.show();
		body.appendChild(_div);
		_div.style.marginLeft = - _div.offsetWidth/2 + 'px';
		_div.style.marginTop = - _div.offsetHeight/2 + 'px'; 
	};

	var _maskback = function(){
		if (mask_close) {
			if (document.getElementsByClassName('wo-pop-box').length > 0)  body.removeChild(document.getElementsByClassName('wo-pop-box')[0]);
			if (document.getElementsByClassName('wo-tip-box').length > 0) body.removeChild(document.getElementsByClassName('wo-tip-box')[0]);
			return true;
		}else{
			return false;
		};
	};
	//推送处理
	wo.setpush = function(uid, callback){
			var cinfo = plus.push.getClientInfo();
			var cid = cinfo.clientid;
			var token = cinfo.token;
			var cos = (plus.os.name == 'iOS') ? 'iOS' : 'Android';
			var url = 'user/pushcid';
			var param = {uid: uid, cid: cid, token: token, os: cos};
			wo.post(url, param, function(data){
				if (data.code == 1) {
					callback && callback(true);
				}else{
					callback && callback(null);
				}
			}, function(err){ callback && callback(null); });
	};
	wo.currentpage = function(uid, gid, page, status, pageid, callback){
		pageid = pageid || 0 ;
		var url='system/currentpage';
		var param = {uid: uid, gid:gid, page:page, pageid:pageid, status:status};
		wo.get(url, param, function(){ callback && callback(); }, function(){ callback && callback(); });
	}
	wo.openpush = function(uid){
		plus.push.addEventListener( "receive", function(msg) {
	        if ( msg.aps ) {  // Apple APNS message
	        	if (plus.os.name == 'iOS') {
	        		var msgpayload = JSON.parse(msg.payload.payload);
				    var options = {title: msgpayload.title, sound:"none"};
				    var str = msgpayload.content;
				    msgpayload.from = "LocalMSG";
				    var payload = JSON.stringify(msgpayload);
				    plus.push.createMessage( str, payload, options );
				    var ap = plus.audio.createPlayer("_www/audio/remd.mp3");
				    ap.play();
			    };
	        } else {
	        	if (plus.os.name != 'iOS') {
		        	var msgpayload = JSON.parse(msg.payload);
					var msgType = msgpayload.type;
					var msgGid = msgpayload.gid;
					var msgIMid = msgpayload.imid;
					var msgMsgid = msgpayload.msgid;
					
					setTimeout(function(){
						plus.push.clear();
						switch( msgType ) {
				            case "blog":
				                mui.openWindow({ url: 'group.html?uid='+uid+'&gid='+msgGid, id:'group'+msgGid, show:{aniShow: 'zoom-fade-out'} });
				            break;
				            case "talk":
				            	mui.openWindow({ url: 'group.html?uid='+uid+'&gid='+msgGid, id:'group'+msgGid, show:{aniShow: 'zoom-fade-out'} });
				            	setTimeout(function(){
				            		if (msgIMid == 0) {
					            		mui.openWindow({ url: 'grouptalk.html?uid='+uid+'&gid='+msgGid, id:'grouptalk'+msgGid, show:{aniShow: 'zoom-fade-out'} });
					            	}else{
						                mui.openWindow({ url: 'groupblogtalk.html?uid='+uid+'&gid='+msgGid+'&bid='+msgIMid, id:'groupblogtalk'+msgIMid, show:{aniShow: 'zoom-fade-out'} });
									}
				            	},1000);
			
				            break; 
							case "msg":
								if (msgGid == 0) {
									mui.openWindow({ url: 'navifeed.html?uid='+uid, id:'navifeed', show:{aniShow: 'zoom-fade-out'} });
								}else{
									mui.openWindow({ url: 'group.html?uid='+uid+'&gid='+msgGid, id:'group'+msgGid, show:{aniShow: 'zoom-fade-out'} });
									setTimeout(function(){
										mui.openWindow({ url: 'groupmsg.html?uid='+uid+'&gid='+msgGid+'&mgid='+msgIMid, id:'groupmsg'+msgIMid, show:{aniShow: 'zoom-fade-out'}});
									},1000);
				                }
				            break; 
				            case "notify":
				                mui.openWindow({ url: 'groupnotify.html?uid='+uid+'&gid='+msgGid, id:'groupnotify', createNew:true, show:{aniShow: 'zoom-fade-out'} });
				            break;
				            default:
				            break;
			          	}						
					},600);							
				}
	        }
		}, false);
		
		plus.push.addEventListener( "click", function( msg ) {
			if (plus.os.name == 'iOS') {
				//查看是否是本地短信
				var isLocalMsg = false;
				if (!msg.payload.payload) {
					var tmppayload = JSON.parse(msg.payload);
					isLocalMsg = (tmppayload.from && tmppayload.from == 'LocalMSG' ) ? true : false;  
				};
				
				var msgpayload = (isLocalMsg) ? JSON.parse(msg.payload) : JSON.parse(msg.payload.payload);
				var msgType = msgpayload.type;
				var msgGid = msgpayload.gid;
				var msgIMid = msgpayload.imid;
				var msgMsgid = msgpayload.msgid;

				setTimeout(function(){
					plus.push.clear();
					switch( msgType ) {
			            case "blog":
			                mui.openWindow({ url: 'group.html?uid='+uid+'&gid='+msgGid, id:'group'+msgGid, show:{aniShow: 'zoom-fade-out'} });
			            break;
			            case "talk":
			            	mui.openWindow({ url: 'group.html?uid='+uid+'&gid='+msgGid, id:'group'+msgGid, show:{aniShow: 'zoom-fade-out'} });
			            	setTimeout(function(){
			            		if (msgIMid == 0) {
				            		mui.openWindow({ url: 'grouptalk.html?uid='+uid+'&gid='+msgGid, id:'grouptalk'+msgGid, show:{aniShow: 'zoom-fade-out'} });
				            	}else{
					                mui.openWindow({ url: 'groupblogtalk.html?uid='+uid+'&gid='+msgGid+'&bid='+msgIMid, id:'groupblogtalk'+msgIMid, show:{aniShow: 'zoom-fade-out'} });
								}
			            	},1000);
		
			            break; 
						case "msg":
							if (msgGid == 0) {
								mui.openWindow({ url: 'navifeed.html?uid='+uid, id:'navifeed', show:{aniShow: 'zoom-fade-out'} });
							}else{
								mui.openWindow({ url: 'group.html?uid='+uid+'&gid='+msgGid, id:'group'+msgGid, show:{aniShow: 'zoom-fade-out'} });
								setTimeout(function(){
									mui.openWindow({ url: 'groupmsg.html?uid='+uid+'&gid='+msgGid+'&mgid='+msgIMid, id:'groupmsg'+msgIMid, show:{aniShow: 'zoom-fade-out'}});
								},1000);
			                }
			            break; 
			            case "notify":
			                mui.openWindow({ url: 'groupnotify.html?uid='+uid+'&gid='+msgGid, id:'groupnotify', createNew:true, show:{aniShow: 'zoom-fade-out'} });
			            break;
			            default:
			            break;
		          	}						
				},600);				
			}
		}, false );
	}	
	
	// 本地数据处理
	var _opendb = window.openDatabase('com.woqu.appDB', '1.1', 'db_woqu', 20 * 1024 * 1024);
	wo.excute = function(arrSql, callback){
		var db = _opendb;
		if (db && arrSql.length > 0) {
			var data = arrSql.shift();
			if (data) { 
				db.transaction(function(tx){
					tx.executeSql(data, [], function(tx, result){ wo.excute(arrSql, callback); }, function(tx, err){ callback && callback(); console.log(err.message+'##data:'+data); });
				});
			}else{ callback && callback();  console.log('sql 数据错误');}; 
		}else{
			callback && callback();
		};
	};
	wo.update = function(sql, arr, callback){
		var db = _opendb;
		if(db &&sql) db.transaction(function(tx){ tx.executeSql(sql, arr, function(){ callback && callback(); }, function(tx,err){ callback && callback(); console.log(err.message); }); });
	};
	wo.delete = function(sql, arr){
		wo.update(sql,arr);
	};
	wo.query = function(sql, arr, callback){
		var db = _opendb;
		if(db && sql) db.transaction(function(tx){ tx.executeSql(sql, arr, function(tx, results) { callback(results); }, function(tx, err){ callback && callback(null); console.log(err.message +':'+ sql);}); });
	};
	
	//服务器通讯
	wo.post = function(url, param, callback, errback){
		_getserver(url, param, 'post', callback, errback);
	};
	wo.get = function(url, param, callback, errback){
		_getserver(url, param, 'get', callback, errback);
	};
	wo._sign = function(param){
		return _createsign(param);
	};
	var _getserver = function(url, params, type, callback, errback) {
		var param = new Array;
		for (var name in params) {
			params[name] = (params[name] && typeof params[name] ==='object' && Object == params[name].constructor) ? JSON.stringify(params[name]) : params[name];
			param.push([name,params[name]]);
		}
		var sign = _createsign(param);
		var ajParam = params;
		ajParam.sign = sign;
		url = 'http://api.wiqiapp.com/index.php/apiv2/' + url;
		mui.ajax(url,{data: ajParam, dataType:'json', type:type,
			success:function(data) { callback && callback(data); }, 
			error:function(xhr,errtype,errorThrown){ 
				errback && errback(errorThrown); 
				console.log('服务器获取数据错误！类型：' + errtype + '，错误信息:' +  errorThrown + '，错误位置：'+url + '.参数：' + JSON.stringify(params)); 
			}
		});
	};
	var _createsign = function(paramarr){
		  var sign = 'Bu73hXBHRx4RppTa', i;
		  paramarr.sort(function(a,b){return a[0].toUpperCase()>b[0].toUpperCase()?1:-1});
		   if (paramarr instanceof Array) {
			   for (i in paramarr){
			       if ((paramarr[i][0] != '') && (paramarr[i][1] != '')) {
			    	   sign = sign + paramarr[i][0] + paramarr[i][1];
			       }
			   }
		   }
		   sign = hex_md5(sign);
		   return sign.toUpperCase(); 
	};
	var hexcase=0;function hex_md5(a){return rstr2hex(rstr_md5(str2rstr_utf8(a)))}function hex_hmac_md5(a,b){return rstr2hex(rstr_hmac_md5(str2rstr_utf8(a),str2rstr_utf8(b)))}function md5_vm_test(){return hex_md5("abc").toLowerCase()=="900150983cd24fb0d6963f7d28e17f72"}function rstr_md5(a){return binl2rstr(binl_md5(rstr2binl(a),a.length*8))}function rstr_hmac_md5(c,f){var e=rstr2binl(c);if(e.length>16){e=binl_md5(e,c.length*8)}var a=Array(16),d=Array(16);for(var b=0;b<16;b++){a[b]=e[b]^909522486;d[b]=e[b]^1549556828}var g=binl_md5(a.concat(rstr2binl(f)),512+f.length*8);return binl2rstr(binl_md5(d.concat(g),512+128))}function rstr2hex(c){try{hexcase}catch(g){hexcase=0}var f=hexcase?"0123456789ABCDEF":"0123456789abcdef";var b="";var a;for(var d=0;d<c.length;d++){a=c.charCodeAt(d);b+=f.charAt((a>>>4)&15)+f.charAt(a&15)}return b}function str2rstr_utf8(c){var b="";var d=-1;var a,e;while(++d<c.length){a=c.charCodeAt(d);e=d+1<c.length?c.charCodeAt(d+1):0;if(55296<=a&&a<=56319&&56320<=e&&e<=57343){a=65536+((a&1023)<<10)+(e&1023);d++}if(a<=127){b+=String.fromCharCode(a)}else{if(a<=2047){b+=String.fromCharCode(192|((a>>>6)&31),128|(a&63))}else{if(a<=65535){b+=String.fromCharCode(224|((a>>>12)&15),128|((a>>>6)&63),128|(a&63))}else{if(a<=2097151){b+=String.fromCharCode(240|((a>>>18)&7),128|((a>>>12)&63),128|((a>>>6)&63),128|(a&63))}}}}}return b}function rstr2binl(b){var a=Array(b.length>>2);for(var c=0;c<a.length;c++){a[c]=0}for(var c=0;c<b.length*8;c+=8){a[c>>5]|=(b.charCodeAt(c/8)&255)<<(c%32)}return a}function binl2rstr(b){var a="";for(var c=0;c<b.length*32;c+=8){a+=String.fromCharCode((b[c>>5]>>>(c%32))&255)}return a}function binl_md5(p,k){p[k>>5]|=128<<((k)%32);p[(((k+64)>>>9)<<4)+14]=k;var o=1732584193;var n=-271733879;var m=-1732584194;var l=271733878;for(var g=0;g<p.length;g+=16){var j=o;var h=n;var f=m;var e=l;o=md5_ff(o,n,m,l,p[g+0],7,-680876936);l=md5_ff(l,o,n,m,p[g+1],12,-389564586);m=md5_ff(m,l,o,n,p[g+2],17,606105819);n=md5_ff(n,m,l,o,p[g+3],22,-1044525330);o=md5_ff(o,n,m,l,p[g+4],7,-176418897);l=md5_ff(l,o,n,m,p[g+5],12,1200080426);m=md5_ff(m,l,o,n,p[g+6],17,-1473231341);n=md5_ff(n,m,l,o,p[g+7],22,-45705983);o=md5_ff(o,n,m,l,p[g+8],7,1770035416);l=md5_ff(l,o,n,m,p[g+9],12,-1958414417);m=md5_ff(m,l,o,n,p[g+10],17,-42063);n=md5_ff(n,m,l,o,p[g+11],22,-1990404162);o=md5_ff(o,n,m,l,p[g+12],7,1804603682);l=md5_ff(l,o,n,m,p[g+13],12,-40341101);m=md5_ff(m,l,o,n,p[g+14],17,-1502002290);n=md5_ff(n,m,l,o,p[g+15],22,1236535329);o=md5_gg(o,n,m,l,p[g+1],5,-165796510);l=md5_gg(l,o,n,m,p[g+6],9,-1069501632);m=md5_gg(m,l,o,n,p[g+11],14,643717713);n=md5_gg(n,m,l,o,p[g+0],20,-373897302);o=md5_gg(o,n,m,l,p[g+5],5,-701558691);l=md5_gg(l,o,n,m,p[g+10],9,38016083);m=md5_gg(m,l,o,n,p[g+15],14,-660478335);n=md5_gg(n,m,l,o,p[g+4],20,-405537848);o=md5_gg(o,n,m,l,p[g+9],5,568446438);l=md5_gg(l,o,n,m,p[g+14],9,-1019803690);m=md5_gg(m,l,o,n,p[g+3],14,-187363961);n=md5_gg(n,m,l,o,p[g+8],20,1163531501);o=md5_gg(o,n,m,l,p[g+13],5,-1444681467);l=md5_gg(l,o,n,m,p[g+2],9,-51403784);m=md5_gg(m,l,o,n,p[g+7],14,1735328473);n=md5_gg(n,m,l,o,p[g+12],20,-1926607734);o=md5_hh(o,n,m,l,p[g+5],4,-378558);l=md5_hh(l,o,n,m,p[g+8],11,-2022574463);m=md5_hh(m,l,o,n,p[g+11],16,1839030562);n=md5_hh(n,m,l,o,p[g+14],23,-35309556);o=md5_hh(o,n,m,l,p[g+1],4,-1530992060);l=md5_hh(l,o,n,m,p[g+4],11,1272893353);m=md5_hh(m,l,o,n,p[g+7],16,-155497632);n=md5_hh(n,m,l,o,p[g+10],23,-1094730640);o=md5_hh(o,n,m,l,p[g+13],4,681279174);l=md5_hh(l,o,n,m,p[g+0],11,-358537222);m=md5_hh(m,l,o,n,p[g+3],16,-722521979);n=md5_hh(n,m,l,o,p[g+6],23,76029189);o=md5_hh(o,n,m,l,p[g+9],4,-640364487);l=md5_hh(l,o,n,m,p[g+12],11,-421815835);m=md5_hh(m,l,o,n,p[g+15],16,530742520);n=md5_hh(n,m,l,o,p[g+2],23,-995338651);o=md5_ii(o,n,m,l,p[g+0],6,-198630844);l=md5_ii(l,o,n,m,p[g+7],10,1126891415);m=md5_ii(m,l,o,n,p[g+14],15,-1416354905);n=md5_ii(n,m,l,o,p[g+5],21,-57434055);o=md5_ii(o,n,m,l,p[g+12],6,1700485571);l=md5_ii(l,o,n,m,p[g+3],10,-1894986606);m=md5_ii(m,l,o,n,p[g+10],15,-1051523);n=md5_ii(n,m,l,o,p[g+1],21,-2054922799);o=md5_ii(o,n,m,l,p[g+8],6,1873313359);l=md5_ii(l,o,n,m,p[g+15],10,-30611744);m=md5_ii(m,l,o,n,p[g+6],15,-1560198380);n=md5_ii(n,m,l,o,p[g+13],21,1309151649);o=md5_ii(o,n,m,l,p[g+4],6,-145523070);l=md5_ii(l,o,n,m,p[g+11],10,-1120210379);m=md5_ii(m,l,o,n,p[g+2],15,718787259);n=md5_ii(n,m,l,o,p[g+9],21,-343485551);o=safe_add(o,j);n=safe_add(n,h);m=safe_add(m,f);l=safe_add(l,e)}return Array(o,n,m,l)}function md5_cmn(h,e,d,c,g,f){return safe_add(bit_rol(safe_add(safe_add(e,h),safe_add(c,f)),g),d)}function md5_ff(g,f,k,j,e,i,h){return md5_cmn((f&k)|((~f)&j),g,f,e,i,h)}function md5_gg(g,f,k,j,e,i,h){return md5_cmn((f&j)|(k&(~j)),g,f,e,i,h)}function md5_hh(g,f,k,j,e,i,h){return md5_cmn(f^k^j,g,f,e,i,h)}function md5_ii(g,f,k,j,e,i,h){return md5_cmn(k^(f|(~j)),g,f,e,i,h)}function safe_add(a,d){var c=(a&65535)+(d&65535);var b=(a>>16)+(d>>16)+(c>>16);return(b<<16)|(c&65535)}function bit_rol(a,b){return(a<<b)|(a>>>(32-b))};

})(mui,wo);